libglom-1.22: Glom::TranslatableItem Class Reference

libglom-1.22 1.22.0

- Main Page
- Namespaces
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Static Public Member Functions | Protected Attributes
Glom::TranslatableItem Class Reference

TranslatableItem have a map of translation strings - one string for each locale. More...

Inheritance diagram for Glom::TranslatableItem:
[legend]

List of all members.

## Public Types
enum | enumTranslatableItemType { TRANSLATABLE_TYPE_INVALID, TRANSLATABLE_TYPE_FIELD, TRANSLATABLE_TYPE_RELATIONSHIP, TRANSLATABLE_TYPE_LAYOUT_ITEM, TRANSLATABLE_TYPE_CUSTOM_TITLE, TRANSLATABLE_TYPE_PRINT_LAYOUT, TRANSLATABLE_TYPE_REPORT, TRANSLATABLE_TYPE_TABLE, TRANSLATABLE_TYPE_BUTTON, TRANSLATABLE_TYPE_TEXTOBJECT, TRANSLATABLE_TYPE_IMAGEOBJECT, TRANSLATABLE_TYPE_CHOICEVALUE, TRANSLATABLE_TYPE_DATABASE_TITLE }
typedef std::map < Glib::ustring, Glib::ustring > | type_map_locale_to_translations
## Public Member Functions
| TranslatableItem ()
| TranslatableItem (const TranslatableItem& src)
virtual | ~TranslatableItem ()
TranslatableItem& | operator= (const TranslatableItem& src)
bool | operator== (const TranslatableItem& src) const
bool | operator!= (const TranslatableItem& src) const
virtual void | set_name (const Glib::ustring& name)
| Set the non-translated identifier name.
virtual Glib::ustring | get_name () const
| Get the non-translated identifier name.
bool | get_name_not_empty () const
virtual Glib::ustring | get_title_or_name (const Glib::ustring& locale) const
virtual Glib::ustring | get_title (const Glib::ustring& locale) const
| Get the title's translation for the specified locale, falling back to the original text if there is no translation.
virtual Glib::ustring | get_title_original () const
| Get the title's original (non-translated, usually English) text.
Glib::ustring | get_title_translation (const Glib::ustring& locale, bool fallback=true) const
| Get the title's translation for the specified locale, optionally falling back to a locale of the same language, and then falling back to the original.
void | set_title (const Glib::ustring& title, const Glib::ustring& locale)
| Set the title's translation for the specified locale.
void | set_title_original (const Glib::ustring& title)
| Set the title's original (non-translated, usually English) text.
void | clear_title_in_all_locales ()
| Clear the original title and any translations of the title.
bool | get_has_translations () const
enumTranslatableItemType | get_translatable_item_type () const
## Static Public Member Functions
static Glib::ustring | get_translatable_type_name (enumTranslatableItemType item_type)
static Glib::ustring | get_translatable_type_name_nontranslated (enumTranslatableItemType item_type)
| The non-translated name is used for the context in gettext .po files.
## Protected Attributes
enumTranslatableItemType | m_translatable_item_type

## Detailed Description

TranslatableItem have a map of translation strings - one string for each locale.

## Member Typedef Documentation

typedef std::map<Glib::ustring, Glib::ustring> Glom::TranslatableItem::type_map_locale_to_translations

## Member Enumeration Documentation

enum Glom::TranslatableItem::enumTranslatableItemType

Enumerator:

  TRANSLATABLE_TYPE_INVALID |
  TRANSLATABLE_TYPE_FIELD |
  TRANSLATABLE_TYPE_RELATIONSHIP |
  TRANSLATABLE_TYPE_LAYOUT_ITEM |
  TRANSLATABLE_TYPE_CUSTOM_TITLE |
  TRANSLATABLE_TYPE_PRINT_LAYOUT |
  TRANSLATABLE_TYPE_REPORT |
  TRANSLATABLE_TYPE_TABLE |
  TRANSLATABLE_TYPE_BUTTON |
  TRANSLATABLE_TYPE_TEXTOBJECT |
  TRANSLATABLE_TYPE_IMAGEOBJECT |
  TRANSLATABLE_TYPE_CHOICEVALUE |
  TRANSLATABLE_TYPE_DATABASE_TITLE |

## Constructor & Destructor Documentation

Glom::TranslatableItem::TranslatableItem | ( |  | ) |

Glom::TranslatableItem::TranslatableItem | ( | const TranslatableItem& | src | ) |

virtual Glom::TranslatableItem::~TranslatableItem | ( |  | ) | `[virtual]`

## Member Function Documentation

void Glom::TranslatableItem::clear_title_in_all_locales | ( |  | ) |

Clear the original title and any translations of the title.

bool Glom::TranslatableItem::get_has_translations | ( |  | ) | const

virtual Glib::ustring Glom::TranslatableItem::get_name | ( |  | ) | const`[virtual]`

Get the non-translated identifier name.

Reimplemented in Glom::Field, and Glom::LayoutItem_Field.

bool Glom::TranslatableItem::get_name_not_empty | ( |  | ) | const

virtual Glib::ustring Glom::TranslatableItem::get_title | ( | const Glib::ustring & | locale | ) | const`[virtual]`

Get the title's translation for the specified locale, falling back to the original text if there is no translation.

See also get_title_translation() and get_title_original(), which (optionally) do not use fallbacks.

Parameters:

  locale | The locale whose title text should be returned. If this is empty then the original text will be returned.

Returns:
  The text of the title.

Reimplemented in Glom::LayoutItem_Field, Glom::LayoutItem_FieldSummary, and Glom::LayoutItem_Portal.

virtual Glib::ustring Glom::TranslatableItem::get_title_or_name | ( | const Glib::ustring & | locale | ) | const`[virtual]`

Reimplemented in Glom::LayoutItem_Field, Glom::LayoutItem_FieldSummary, and Glom::LayoutItem_Portal.

virtual Glib::ustring Glom::TranslatableItem::get_title_original | ( |  | ) | const`[virtual]`

Get the title's original (non-translated, usually English) text.

Reimplemented in Glom::ChoiceValue.

Glib::ustring Glom::TranslatableItem::get_title_translation | ( | const Glib::ustring & | locale,
|  | bool | fallback = `true`
| ) |  | const

Get the title's translation for the specified locale, optionally falling back to a locale of the same language, and then falling back to the original.

Calling this with the current locale is the same as calling get_title_original().

enumTranslatableItemType Glom::TranslatableItem::get_translatable_item_type | ( |  | ) | const

static Glib::ustring Glom::TranslatableItem::get_translatable_type_name | ( | enumTranslatableItemType | item_type | ) | `[static]`

static Glib::ustring Glom::TranslatableItem::get_translatable_type_name_nontranslated | ( | enumTranslatableItemType | item_type | ) | `[static]`

The non-translated name is used for the context in gettext .po files.

bool Glom::TranslatableItem::operator!= | ( | const TranslatableItem& | src | ) | const

TranslatableItem& Glom::TranslatableItem::operator= | ( | const TranslatableItem& | src | ) |

bool Glom::TranslatableItem::operator== | ( | const TranslatableItem& | src | ) | const

virtual void Glom::TranslatableItem::set_name | ( | const Glib::ustring & | name | ) | `[virtual]`

Set the non-translated identifier name.

Reimplemented in Glom::Field, and Glom::LayoutItem_Field.

void Glom::TranslatableItem::set_title | ( | const Glib::ustring & | title,
|  | const Glib::ustring & | locale
| ) |  |

Set the title's translation for the specified locale.

Parameters:

  title | The text of the title.
  locale | The locale whose title text should be set. If this is empty then the original text will be set.

void Glom::TranslatableItem::set_title_original | ( | const Glib::ustring & | title | ) |

Set the title's original (non-translated, usually English) text.

This is the same as calling set_title() with an empty locale parameter.

## Member Data Documentation

enumTranslatableItemType Glom::TranslatableItem::m_translatable_item_type`[protected]`

The documentation for this class was generated from the following file:

- libglom/data_structure/translatable_item.h